/*============================================================================
: LiFe
:     
:   (  _)
: ..
  : 28.02.2003
==============================================================================*/
#include "_main.h"

#include <assert.h>
#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "sm_main.h"
#include "da_main.h"

#define _VISIBLE 8	// - ,    

/* ==========================   =======================*/
/* ---------------------------------  --------------------------------*/
//typedef struct time time_t;
typedef float x_t;
/* ---------------------------------  --------------------------------*/
static int _fV[SM_MAX_DIM];		/*  . - */
static int _bV[SM_MAX_DIM];		/*   - */
static float _T[SM_MAX_DIM][SM_MAX_DIM];	/*  - */

static int _fV_[SM_MAX_DIM];		/*    . - */
static int _bV_[SM_MAX_DIM];		/*     - */
static float _T_[SM_MAX_DIM][SM_MAX_DIM];		/*   - */

static int _n;							/*  -  */
static int _n_;						//  
static int _m;							/* -   */
static int _m_;						//  

static int _r;							/* - - - */
static float _H[SM_MAX_DIM][SM_MAX_DIM];/* . -  :
														H[i][1]*x_1+...+H[i][n]*x_n <= H[i][0] */

static float _x[SM_MAX_DIM];					/*     */
static float _X_[SM_MAX_DIM][SM_MAX_DIM];					/*    
															  +< -> */
static float _X[SM_MAX_L][SM_MAX_DIM];		/* L   */

static float _y[SM_MAX_DIM];		/*    */
static float _Y[SM_MAX_L][SM_MAX_DIM];		/* L   .  */
static float _Y_[SM_MAX_DIM][SM_MAX_DIM];	/*   +< -> */

static float _z[SM_MAX_DIM];					//   z_1*x_1+...+z_n*x_n+z_0 = 0
static float _Z[SM_MAX_DIM][SM_MAX_DIM];	//    

static int _count;	//  
static char* _input =SM_INPUT;	//  

static int _kA;			//      
static int _kB;			//      B

/* ==================================  ===============================*/
void 	_addLE(int*n,int*m,int*basicVars,int*freeVars,
							float*symplexTable,float*inequation);
int 	_addGE(int*n,int*m,int*basicVars,int*freeVars,
							float*symplexTable,float*inequation);
int 	_satisfy(int r,float *nonFormalConstraints,float *solution,int n);
int 	_probe(int iH,float *solution,int n_m);
void	_calcTime(struct time startT,struct time stopT,int*hour,int*min,int*sec,int*hund);
void 	_copy(int n, int m, int *bV,int *fV,float *T,
				int *bV_,int *fV_,float *T_);
void	_correct(float *x,int n,float s);
int	_education(int iH,float *x,int rnd,float s);
int 	_execSM( int n,int m,int *bV,int *fV,float *T);
int	_inM(float *x,float *M_,int kM_,int n);
float	_dist(float *x,float *y,int n);
void	_push(float *x,float *X,int L);
void 	_skipComments(FILE*, fpos_t*);
void	_randomize(int iH,float*x,float s);
void	_readData(void);
void	_roundX(int n,int m,float *x,float delta);
/*--------------------------------- main -------------------------------------*/
void main() {
   int j,iH;
   int done;
	struct time startT;
	struct time stopT;
	int hour, min, sec, hund;
   int C;
   int xDone, yDone;
	float xDist,yDist;

   assert(_DELTAH<_EPSILONX);
   assert(_DELTAH<_EPSILONY);
#ifdef EXACT_ON
	assert(_L>=1);
#else
	assert(_L>=2);
#endif
   assert(_L<=SM_MAX_L+1);
   assert(_PC>=1000);
   assert(_rRING>0);assert(_rRING<1);

 	_readData();

   //     (   )->
  	_copy(_n,_m,_bV,_fV,(void*)_T,_bV_,_fV_,(void*)_T_);
	done=_execSM(_n,_m,_bV_,_fV_,(void*)_T_);
 	if (!done){
		printf("The problem's unresolvable.\n\nPress ENTER");
		getchar();
		abort();
	};

  	sm_getX(_n,_m,_bV_,(void*)_T_,_x);
   _roundX(_n,_m,_x,_DELTAX);

	if(_r==0){/*    */
	   for(j=1; j<=_n; j++)printf("%0.4f ",_x[j]);
	   printf("\n\nPress ENTER");getchar();/**/
		abort();//   .
  	};


for(iH=1;iH<=_r;iH++){//    
	printf("\n----------------------- Nonformal %d -----------------------",iH);
	gettime(&startT);
   _count=0;
   do{// ---------      ---------->
		#ifdef _RND
			randomize();
		#endif
   	_count++;

      if(_count>_MAX_COUNT){
			printf("\n\nAbnormal termination: ################## Iteration count overflow ####################");
      	abort();
      };

      //   ->
      C=da_analysis(_z,_n-_m);
		if	(C==0){//  -  -   ..
			printf("\n\n------------> Overtime");
      	break;

      };

		// ------------   -------------
		//     _T_ ->
		_copy(_n,_m,_bV,_fV,(void*)_T,_bV_,_fV_,(void*)_T_);
	   _n_=_n;
	   _m_=_m;
	   _z[0]=-_z[0]; /*       */

		//     "<="  -
		_addLE(&_n_,&_m_,_bV_,_fV_,(void*)_T_,_z);
	   _z[0]=-_z[0]; /*        */

      // :    (  )
		done=_execSM(_n_,_m_,_bV_,_fV_,(void*)_T_);
		if (!done){
			printf("The problem's unresolvable.\n\nPress ENTER");
			getchar();
			abort();
		};

	  	sm_getX(_n_,_m_,_bV_,(void*)_T_,_x);
	   _roundX(_n_,_m_,_x,_DELTAX);

#ifndef EXACT_ON //   
      xDone=0;
	   if(_count>_L){
	     	xDone=1;
	     	for(j=0;j<=_L-1;j++)
		      if(_dist(_x,_X[j],_n-_m)>=_EPSILON){
		      	xDone=0;break;}; //   
	     };
		_push(_x,(void*)_X,_L); //  x   X
#endif
#ifdef EXACT_ON //      
		_push(_x,(void*)_X,_L); //  x   X
      xDone=0;
	   if(_count>_L){
	     	xDone=1;
	     	for(j=0;j<=_L-1;j++)
		      if(_dist(_X_[iH],_X[j],_n-_m)>=_EPSILONX){
		      	xDone=0;break;}; //   
	     };
#endif
		xDist=_dist(_x,_X_[iH],_n-_m);
      if(!xDone)
	   	  _education(iH,_x,_RANDOMIZATION_X,xDist); //   

     	// ------------   -------------
		//     _T_ ->
		_copy(_n,_m,_bV,_fV,(void*)_T,_bV_,_fV_,(void*)_T_);
	   _n_=_n;
	   _m_=_m;
	   _z[0]=-_z[0]; /*       */

      for(j=0;j<=_n_-_m_;j++) //   
      	_T_[0][j]=-_T_[0][j];

		//     ">="  -
		done=_addGE(&_n_,&_m_,_bV_,_fV_,(void*)_T_,_z);
      _z[0]=-_z[0]; /*        */

	 	if (!done){  //     
			continue;
		};

		//      
	  	done=_execSM(_n_,_m_,_bV_,_fV_,(void*)_T_);
		if (!done){
			printf("\n\nThe problem's unresolvable.\n");
			getchar();
			abort();
		};

  		sm_getX(_n_,_m_,_bV_,(void*)_T_,_y);
      _roundX(_n_,_m_,_y,_DELTAY);

#ifndef EXACT_ON //   
     	yDone=0;
      if(_count>_L){
      	yDone=1;
      	for(j=0;j<=_L-1;j++)
		      if(_dist(_y,_Y[j],_n-_m)>=_EPSILON){
		      	yDone=0;break;}; //   
      };
		_push(_y,(void*)_Y,_L); //  x   X
#endif
#ifdef EXACT_ON //      
		_push(_y,(void*)_Y,_L); //  x   X
     	yDone=0;
      if(_count>_L){
      	yDone=1;
      	for(j=0;j<=_L-1;j++)
		      if(_dist(_Y_[iH],_Y[j],_n-_m)>=_EPSILONY){
		      	yDone=0;break;}; //   
      };
#endif
      yDist=_dist(_y,_Y_[iH],_n-_m);
		if(!yDone)
	      _education(iH,_y,_RANDOMIZATION_Y,yDist); //   

		//  
		gettime(&stopT);
		_calcTime(startT,stopT,&hour,&min,&sec,&hund);

		// ==========    ===========
		printf("\n %3d | ",_count);
		printf("%10.3f\t%10.3f",xDist,yDist);
		if(hour>0)
			printf("\t | %d:%02d:%02d",hour,min,sec);
		else
			printf("\t | %d:%02d",min,sec);

		printf("\t | %6d |",C);

		if(xDone&&yDone)

      	break;

   }while(1);

   printf("\n\nx:");// ---------------  x ----------
   for(j=1; j<=_n-_m; j++)
     	printf("\t%3.3f ",_x[j]);
   printf("\n\ny:");// ---------------  y ----------
   for(j=1; j<=_n-_m; j++)
     	printf("\t%3.3f ",_y[j]);
	printf("\n\nz:");// ---------------  z ----------
   for(j=1; j<=_n-_m; j++)
     	printf("\t%1.3f ",_z[j]);
   printf("\t%4.0f ",-_z[0]);

	printf("\n\nIteration count: %d",_count);
	gettime(&stopT);// ---------------   ----------
	_calcTime(startT,stopT,&hour,&min,&sec,&hund);
	printf("\n\n\007Elapsed time: ");
	if(hour>0)
		printf("%d:%02d:%02d.%02d",hour,min,sec,hund);
	else if(min>0)
		printf("%d:%02d.%02d",min,sec,hund);
	else
		printf("%02d.%02d",sec,hund);
   printf("\t= %d seconds\n\n"
   		,hour*3600+min*60+sec);

   _z[0]=-_z[0]; /*       */
	//      _Z (z[0] - !)
   for(j=0; j<=_n-_m; j++)
   	_Z[iH][j]=_z[j];

   for(j=0; j<=_n-_m; j++)
   	_z[0]=0; /*    */
   _count=0;
   da_reSetAB(_kA,_kB);
};//

	//      -
	for(iH=1;iH<=_r;iH++)//    
   	_addLE(&_n,&_m,_bV,_fV,(void*)_T,_Z[iH]);

   done=_execSM(_n,_m,_bV,_fV,(void*)_T);
 	if (!done){
		printf("The problem's unresolvable.\n\nPress ENTER");
		getchar();
		abort();
	};

  	sm_getX(_n,_m,_bV,(void*)_T,_x);
   _roundX(_n,_m,_x,_DELTAX);

	printf("\n\nx:");
   for(j=1; j<=_n-_m; j++)
     	printf("\t%3.3f ",_x[j]);

	printf("\n\nDistance to x_: %3.3f",_dist(_x,_X_[0],_n-_m));
	printf("\n\n================ DONE! ===========================");

};

/* =============================   ==========================*/
/*------------------------------- _probe -----------------------------------*/
static /*  x     _i(x)<=0 */
int /* :
	1 -  i: _i(x)>0;
   0 - (  i: (x)<=0)  ( i: (x)=0);
   -1-   i: (x)<0*/
_probe( /* : */
	 int iH 		/*    _i(x)<=0 */
	,float *x	/*  : x[1]=x_1;...;x[n]=x_n */
	,int n_m 	/* .  - (n-m)*/
){
   int j;
   float distH;
   float numerator,denominator; //    = ABS(numerator)/SQRT(denominator)
   int res=-1;

   	numerator=0;
   	denominator=0;
   	for(j=1; j<=n_m; j++){
      	numerator+=_H[iH][j]*x[j];
         denominator+=_H[iH][j]*_H[iH][j];
      };
		numerator-=_H[iH][0];
      distH=sqrt(numerator*numerator/denominator);
      if(distH>_DELTAH && numerator>0)
      	return 1;
      else if(distH<=_DELTAH)
      	res=0;

   return res;
};

/*----------------------------- _addLE ---------------------------------*/
/*     "<="  - + .
	    . */
static void _addLE(
	/* : */
	int *n_, 			/*  . - */
	int *m_, 			/* .  - - */
	int *bV,		/*  - - - (   1) */
	int *fV,		/*  - - - (   1) */
	float *T, 	/*  - */
	float *z	/*   :
					z[1]*x_1+...+z[n]*x_n <= z[0],  z[0]>=0 */
)
{
#define a(i,j) T[(i)*SM_MAX_DIM+j]
#define n *n_
#define m *m_
   int k=n-m;
   int i,j;

   /*       */
   for (i=1; i<=m; i++)
   	if(z[bV[i]]!=0){
		   for (j=1; j<=k; j++)
         	z[fV[j]]-=a(i,j)*z[bV[i]];
         z[0]-=a(i,0)*z[bV[i]];
			z[bV[i]]=0;
      };

   /*     .  (- -> -) */
   n=n+1;assert(n<SM_MAX_DIM);

   m=m+1;assert(m<SM_MAX_DIM);
   bV[m]=n;

   /*       */
   for (j=1; j<=k; j++)
   	a(m,j)=z[fV[j]];
   a(m,0)=z[0];

#undef n
#undef m
#undef a
};

/*----------------------------- _skipComments --------------------------------*/
/*      (,   '%') */
static void _skipComments(FILE *stream, fpos_t *pos){
	fscanf(stream, "\n");
	fgetpos(stream,pos);
	while(getc(stream)=='%'){
		while(getc(stream)!=10);
		fscanf(stream, "\n");
		fgetpos(stream,pos);
	};
	fsetpos(stream,pos);
};

/*----------------------------- _correct --------------------------------*/
/*  x   ( -, - . -!) */
static void _correct(
	float *x,			/*   */
	int n, 				/*  (- ) */
   float s				/*   > 0 */
){
	int j,l;
   float u;
   float ro,rO;	//  

   ro=s*_rRING;
	assert(ro*_PC>10);// <--   _PC!
	rO=s*(1-_rRING);
	for(j=1;j<=n-_m;j++){
	   l=rand();
 		u=	((float)(random((int)(ro*_PC))+(int)(rO*_PC)))/_PC; //   !
		if(l%2)
			x[_fV[j]]+=u;
		else if(x[_fV[j]]-u>=0)
			x[_fV[j]]-=u;
		assert(x[_fV[j]]>=0);
	};
};

/*------------------------------- _readData ----------------------------------*/
/*      */
static void _readData() {
	FILE *stream;
	fpos_t pos;
   int	i, j;
   float x;

	stream = fopen(_input, "r");
	if (stream== NULL){
		printf("Cannot open input file.\n\nPress ENTER");
		getchar();
		abort();
	};

	_skipComments(stream,&pos);
   fscanf(stream, "%d", &_n);/*   -  */
	_skipComments(stream,&pos);
   fscanf(stream, "%d", &_m);/*  -   */
	printf("n=\%d\tm=%d\n\n",_n,_m);
   assert(_m<SM_MAX_DIM);
   assert(_n-_m<SM_MAX_DIM);
   assert(_n-_m>1);
   assert(_m<_n);

	_skipComments(stream,&pos);
   for (j=1; j<=_n-_m; j++) /*     */
		fscanf(stream, "%f", &_X_[0][j]);

	_skipComments(stream,&pos);
   for (j=1; j<=_n-_m; j++) /*   ()   */
		fscanf(stream, "%d", &_fV[j]);
   for (i=1; i<=_m; i++){
		fscanf(stream, "\n%d", &_bV[i]); /*  i-   */
   	for (j=1; j<=_n-_m; j++){ /*  i-   A */
			fscanf(stream, "%f", &x);
         _T[i][j]=(float)x;
      };
		fscanf(stream, "%f\n", &x); /*  i- .  b_i */
      _T[i][0]=(float)x;
	};
	for (j=1; j<=_n-_m; j++){ /*   0-    
   									 -Q_0 */
		fscanf(stream, "%f", &x);
      _T[0][j]=(float)x;
	   assert((j==_n-_m)|(!feof(stream)));
	};
	fscanf(stream, "%f\n", &x); /*  -Q_0 */
   _T[0][0]=(float)x;

   /*       + */
	_skipComments(stream,&pos);
   if(fscanf(stream, "%d", &_r)!=EOF){/*  - - - */
		_skipComments(stream,&pos);
	   for (i=1; i<=_r; i++){
	   	for (j=1; j<=_n; j++){ /*  i- - - */
				fscanf(stream, "%f", &x);
	         _H[i][j]=(float)x;
	      };
			fscanf(stream, "%f", &x);/*     */
	      _H[i][0]=(float)x;
	      assert((i==_r)|(!feof(stream)));
		};

		_skipComments(stream,&pos);
	   for (i=1; i<=_r; i++)
	   	for (j=1; j<=_n-_m; j++){ /*  i-   + */
				fscanf(stream, "%f", &x);
	         _X_[i][j]=(float)x;
	      };

		_skipComments(stream,&pos);
	   for (i=1; i<=_r; i++)
	   	for (j=1; j<=_n-_m; j++){ /*  i-   + */
				fscanf(stream, "%f", &x);
	         _Y_[i][j]=(float)x;
	      };
   }else
   	_r=0;

   /*    A (  - -) */
	_skipComments(stream,&pos);
   if(fscanf(stream, "%d", &_kA)!=EOF){/*    A */
	   assert(_kA<DA_MAX_DIM);
	   for (i=1; i<=_kA; i++){
			_skipComments(stream,&pos);
	   	for (j=1; j<=_n; j++) /*  i-   A  _x*/
				fscanf(stream, "%f", &_x[j]);
	      assert((i==_kA)|(!feof(stream)));
         da_addA(_x,_n-_m);
		};
   }else
   	_kA=0;

   /*    B (  - -) */
	_skipComments(stream,&pos);
   if(fscanf(stream, "%d", &_kB)!=EOF){/*    B */
	   assert(_kB<DA_MAX_DIM);
	   for (i=1; i<=_kB; i++){
			_skipComments(stream,&pos);
	   	for (j=1; j<=_n; j++) /*  i-   B  _x*/
				fscanf(stream, "%f", &_x[j]);
	      assert((i==_kB)|(!feof(stream)));
         da_addB(_x,_n-_m);
		};
   }else
   	_kB=0;

  	assert((_r==0)?!_kA:1);
	assert((_r==0)?!_kB:1);

	fclose(stream);
};


/* -------------------------------- _copy ------------------------------------*/

/*   -       

	 */

void _copy(
	int n, 				/*  . - */
	int m, 				/* .  - */
	int *bV,		/*  - - (   1) */
	int *fV,		/*  - - (   1) */
	float *T,	/* - */
	int *bV_,	/*    - - */
	int *fV_,	/*    - - */
	float *T_	/*   - */
){
#define a(i,j) T[(i)*SM_MAX_DIM+j]
#define a_(i,j) T_[(i)*SM_MAX_DIM+j]
   int i,j;
   int k=n-m;

   for(i=0;i<SM_MAX_DIM*SM_MAX_DIM;i++)
   	T_[i]=0;

   /*   - */
   for(i=0;i<=m;i++)
   	for(j=0;j<=k;j++)
	      a_(i,j)=a(i,j);
   for(i=1;i<=m;i++)
		bV_[i]=bV[i];
  	for(j=0;j<=k;j++)
		fV_[j]=fV[j];
#undef a_
#undef a
};

/* -------------------------------- _education ------------------------------------*/
//   
static
int // 1 - 
_education(
	 int iH				//    
	,float *x			//  
	,int randomising	// ?  	0 - ;
   													// 1 -  ;
                                          // 2 - .
	,float s				//  
){
	int res=0;
   int probe;						//   (x)=0
   int inA;
   int inB;

   probe=_probe(iH,x,_n-_m);
   inA=da_inA(x,_n-_m);
   inB=da_inB(x,_n-_m);
   if(inA || inB || probe==0){
		//  x    A  B,    H, 
	   if(inB)printf(" rB ");
	   if(inA)printf(" rA ");
	   if(probe==0)
      	printf(" rH ");
      res=1;
		// 
      if(randomising) // :
			_randomize(iH,x,s);
   }else{
      switch(probe){
      case -1:
	   	da_addB(x,_n-_m); break;
      case 1:
		  	da_addA(x,_n-_m); break;
		default:
			printf("_education: Unpredictable probe x.\n\nPress ENTER");
			getchar();
			abort();/**/
      };
      if(randomising==2) // :
			_randomize(iH,x,s);
printf("\t");
   };
	return res;
};

/* -------------------------------- _execSM ----------------------------------*/
/*    -  . */
static int /* :
			 1 -  ;
          0 -    */
_execSM( /* : */
	int n, 				/*  . - */
	int m, 		/* .  - */
	int *bV,		/*  - - (   1) */
	int *fV,		/*  - - (   1) */
	float *T	/* - (   ),
						  :
                  T_[0,0]=-Q_0;
                  T_[0,1..k] -    (k=n-m);
                  T_[1..m,0] -  b_i;
                  T_[1..m,1..k] -   */
){
	int done;
	/* ---------   ----------> */
   do{
	   done=sm_symplex(n,m,bV,fV,T);
		if (done==-1)
			return 0;
   }while(!done);
	return 1;
};

/* -------------------------------- _roundX ------------------------------------*/
//    -,      _x[]
static void _roundX( /* : */
	int n, 				/*  . - */
	int m, 				/* .  - */
	float *x,	/*  . x[0]    - */
	float delta	/*    */
){
	int j;

   //  x
  	for(j=1;j<=n-m;j++){
     	if(fabs(ROUND(x[j])-x[j])<delta)
				x[j]=ROUND(x[j]);
      if(x[j]<0)
      	x[j]=0;
//      assert(x[j]>=0);
   };

  	for(j=n-m+1;j<=n;j++)//   
     	x[j]=0;/**/
};

/*----------------------------- _addGE ---------------------------------*/
/*     ">="  - + .
	    . */
static
	int /* 1 - , 0 -    */
_addGE(
	/* : */
	int *n_, 			/*  . - */
	int *m_, 			/* .  - - */
	int *bV,		/*  - - - (   1) */
	int *fV,		/*  - - - (   1) */
	float *T, 	/*  - */
	float *z	/*   :
					z[1]*x_1+...+z[n]*x_n <= z[0],  z[0]>=0 */
)
{
#define t(i,j) T[(i)*SM_MAX_DIM+j]
#define n *n_
#define m *m_
#define k (n-m)
static float A[SM_MAX_DIM][SM_MAX_DIM];
   int i,j;
   int done;
   int nn,mm;

   /*    */
   for (i=0; i<=m; i++)
	   for (j=0; j<=n; j++)
      	A[i][j]=0;

   /*      */
   for (i=0; i<=m; i++){
   	A[i][0]=t(i,0); /* .  */
	   for (j=1; j<=k; j++)
      	A[i][fV[j]]=t(i,j); /* .  */
	};
   for (i=1; i<=m; i++)
   	A[i][bV[i]]=1; /* .  */

   /*      */
   n=n+1;assert(n<SM_MAX_DIM);
   m=m+1;assert(m<SM_MAX_DIM);
   for (j=0; j<n; j++)
   	A[m][j]=z[j];
   A[m][n]=-1; /*    */

   /*  -  ..  */
   nn=n;
   mm=m;
   done=sm_canonView(nn,mm,(void*)A,n_,m_,bV,fV,(void*)T);
	if (!done){
		return 0;
	};

	return 1;
#undef n
#undef m
#undef k
#undef t
};

/*----------------------------- _dist ---------------------------------*/
//   x  y
static
float	_dist(float *x,float *y,int n){
int j;
float s=0;

	for(j=1;j<=n;j++)
   	s=s+(x[j]-y[j])*(x[j]-y[j]);

  	return sqrt(s);
};

/*----------------------------- _push ---------------------------------*/
//  x  X
static
void
_push(float *x,float *XX,int L){
#define X(i,j) XX[(i)*SM_MAX_DIM+j]
int i,j;
	for(i=L-2;i>=0;i--)
		for(j=1;j<=_n-_m;j++)
			X(i+1,j)=X(i,j);

	for(j=1;j<=_n-_m;j++)
		X(0,j)=x[j];
#undef X
};

/*----------------------------- _calcTime ---------------------------------*/
//  

static void	_calcTime(struct time startT,struct time stopT,int*hour,int*min,int*sec,int*hund){
	if(stopT.ti_hour<startT.ti_hour)
		*hour=24-startT.ti_hour+stopT.ti_hour;
	else
		*hour=stopT.ti_hour-startT.ti_hour;
	if(stopT.ti_min<startT.ti_min){
		(*hour)--;
		*min=60-startT.ti_min+stopT.ti_min;
	}else
		*min=stopT.ti_min-startT.ti_min;
	if(stopT.ti_sec<startT.ti_sec){
   	if(*sec>0)
			(*min)--;
      else{
			(*hour)--;
         *min=59;
      };
		*sec=60-startT.ti_sec+stopT.ti_sec;
	}else
		*sec=stopT.ti_sec-startT.ti_sec;
	if(stopT.ti_hund<startT.ti_hund){
   	if(*sec>0)
			(*sec)--;
      else{
			(*min)--;
         *sec=59;
      };
		*hund=100-startT.ti_hund+stopT.ti_hund;
	}else
		*hund=stopT.ti_hund-startT.ti_hund;
};

/*----------------------------- _randomize ---------------------------------*/
// 

static void	_randomize(int iH,float*x,float s){
int j;
int probe;						//   (x)=0
int inA;
int inB;

	      for(j=1;j<=_R;j++){
				do{
		        	_correct(x,_n,s); //   .
				   probe=_probe(iH,x,_n-_m);
				   inA=da_inA(x,_n-_m);
				   inB=da_inB(x,_n-_m);
		     	}while(inA || inB || probe==0);

			   /*  */
            switch(probe){
            case -1:
	      		da_addB(x,_n-_m); break;
            case 1:
		      	da_addA(x,_n-_m); break;
				default:
					printf("_education: Unpredictable probe xr.\n\nPress ENTER");
					getchar();
					abort();/**/
            };
	    	};
};
