/*============================================================================
: LiFe
:     
:   (  da_)
: ..
  : 31.07.2003
==============================================================================*/
#include "_main.h"

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <values.h>

#include "da_main.h"
/* ==========================   =======================*/
static float _A[DA_MAX_DIM][SM_MAX_DIM];	// - ,  - - -
static int _kA;						/* -    */
static int _lA=1; //  "" 

static float _B[DA_MAX_DIM][SM_MAX_DIM];	/* - , - - - */
static int _kB;						/* -   B */
static int _lB=1; //  "" 

/* =================================  ===============================*/
int	_approvedByA(float*z,int n,int*_lA);
int	_approvedByB(float*z,int n,int*_lB);
void	_buildIndexA(void);
int 	_correctA(float *z,int n, float cc);
int 	_correctB(float *z,int n, float cc);
//int 	_divideA(float *z,int n, float cc);
float	_dist(float *x,float *y,int n);
int 	_joinA(int ia,float *z,int n, float cc);
int	_lincor(float *z,int n, float cc);
int	_MLincor(float *z,int n, float cc);
int 	_newM(int *Mt,int kM);
/* ============================   =========================*/
/*   */
extern
	int	// 1 - OK; 0 -   ; (-1) - 
da_analysis(
	float *z,	/*     */
	int n		/*   */
){
  	return _lincor(z,n,NULL);
};
/*----------------------------- da_addA --------------------------------*/
/*     */
extern
void da_addA(
	float *x,			/*  */
	int n 				/*  (- ) */
){
	int j;

   _kA++;
   if(_kA>=DA_MAX_DIM-1){
		printf("_addPoint: Education array overflow.\n\nPress ENTER");
		getchar();
		abort();/**/
   };
   for(j=1; j<=n; j++)
   	_A[_kA][j]=x[j];
};

/*----------------------------- da_addB --------------------------------*/
/*     B */
extern
void da_addB(
	float *x,			/*  */
	int n 				/*  (- ) */
){
	int j;

   _kB++;
   if(_kB>=DA_MAX_DIM){
		printf("_addPoint: Education array overflow.\n\nPress ENTER");
		getchar();
		abort();/**/
   };
   for(j=1; j<=n; j++)
   	_B[_kB][j]=x[j];
};

/*----------------------------- da_inA --------------------------------*/
/* x  A? */
extern
int da_inA(
	float *x,			/*  */
	int n 				/*  (- ) */
){
	int i;

	for(i=1; i<=_kA; i++)
   	if(_dist(x,_A[i],n)<_DELTAPOINT)
      	return 1;
   return 0;
};

/*----------------------------- da_inB --------------------------------*/
/* x  B? */
extern
int da_inB(
	float *x,			/*  */
	int n 				/*  (- ) */
){
	int i;

	for(i=1; i<=_kB; i++)
   	if(_dist(x,_B[i],n)<_DELTAPOINT)
      	return 1;
   return 0;
};

/*----------------------------- da_reSetAB --------------------------------*/
/*          */
extern void
da_reSetAB(int kA,int kB){
	_kA=kA;
   _kB=kB;
   _lA=1;
   _lB=1;
};
/* =============================   ==========================*/

/*-------------------------------- _lincor -----------------------------------*/
/*  z:
	a_1*z_1 + ... + a_n*z_n + z_0 > 0   a  A
	b_1*z_1 + ... + b_n*z_n + z_0 < 0   b  B
*/
static
	int	// > - - , 0 -   
_lincor(
	float *z,			/*    */
	int n,				/*   */
	float cc				/*   = DA_CC */
){
	int j;
   int Aok, Bok;
   int C;				//  
   float maxZ,minZ;
	float zz[SM_MAX_DIM];

   for(j=1; j<=n; j++)
   	zz[j]=z[j];

   C=0;
   if(cc==NULL)	/*  */
   	cc=DA_CC;

   do{
   	C++;
      if(C>_LCMAX){
		   for(j=1; j<=n; j++)
   			z[j]=zz[j];
			printf("\t | %d",C);/**/
      	return 0;
      };

   	do{/* --   A -- */
	   	/* --    A -- */
		   Aok=_approvedByA(z,n,&_lA);/**/

	      if(!Aok){
		      /*  */
	   	   z[0]+=cc;
	    		for(j=1;j<=n;j++)
	        		z[j]+=_A[_lA][j];
	      };
	   }while(!Aok);

   	do{/* --   B -- */
	   	/* --    B -- */
		   Bok=_approvedByB(z,n,&_lB);/**/

	  	   if(!Bok){
            Aok=0;
		      /*  */
	   	   z[0]-=cc;
	    		for(j=1;j<=n;j++)
	        		z[j]-=_B[_lB][j];
	      };
	   }while(!Bok);

   }while(!(Aok && Bok));

   // 
   maxZ=fabs(z[1]);
   for(j=2; j<=n; j++)
   	maxZ=max(maxZ,fabs(z[j]));
   if(!_EQZERO(maxZ,_DELTAZ))
	   for(j=0; j<=n; j++)
	   	z[j]=z[j]/maxZ;
   for(j=0; j<=n; j++)
	   if(_EQZERO(z[j],_DELTAZ))
	   	z[j]=0;
   minZ=fabs(z[1]);
   for(j=2; j<=n; j++)
   	minZ=min(minZ,fabs(z[j]));
   if(minZ!=0)
	   for(j=0; j<=n; j++)
	   	z[j]=z[j]/minZ;

	return C;
};

/*----------------------------- _dist ---------------------------------*/
//   x  y
static
float	_dist(float *x,float *y,int n){
int j;
float s=0;

	for(j=1;j<=n;j++)
   	s=s+(x[j]-y[j])*(x[j]-y[j]);

  	return sqrt(s);
};

/*----------------------------- _approvedByA ---------------------------------*/
//   z  _lA:
//	a_1*z_1 + ... + a_n*z_n + z_0 > 0   a  A_iA
static
int // 1 - ; 0 - 
_approvedByA(
	 float*z
   ,int n
   ,int*lA_
){
#define lA (*lA_) //  "" 
int Aok=1,i,j;
float s;

	for(i=1;i<=_kA;i++){
    	s=0;
      for(j=1;j<=n;j++)
        	s+=_A[lA][j]*z[j];
      s+=z[0];

   	if(s<0 || _EQZERO(s,_DELTACOR)){
        	Aok=0;
        	break;
		};
	   lA=lA%_kA+1;
	};
   return Aok;
#undef lA
};

/*----------------------------- _approvedByB ---------------------------------*/
//   z  B:
//	b_1*z_1 + ... + b_n*z_n + z_0 < 0   b  B
static
int // 1 - ; 0 - 
_approvedByB(
	 float*z
   ,int n
   ,int*lB_
){
#define lB (*lB_) //  "" 
int Bok=1,i,j;
float s;

   for(i=1;i<=_kB;i++){
  	 	s=0;
     	for(j=1;j<=n;j++)
        	s+=_B[lB][j]*z[j];
      s+=z[0];

		if(s>0 || _EQZERO(s,_DELTACOR)){
	     	Bok=0;
         break;
      };
	   lB=lB%_kB+1;
   };
   return Bok;
#undef lB
};
