/*============================================================================
: LiFe
:        Mod-n
:  
: .. 
  : 18.08.2003
==============================================================================*/
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "_main.h"
#include "sm_main.h"
/* ==========================   =======================*/
//#define _EXACT //   -  -
#define _OUTPUT "20_10.txt"	/*    - */
#define _N_	20					/*   (-  ) */
#define _R_ 10					/*    (<=N)
/* ==========================   =======================*/
#define _M_	((_N_-1)*2+_R_)		/* - ,   */
/* ==========================   =======================*/
#define _K	1000				/*    -  */
/* ---------------------------------  --------------------------------*/
static float _A[SM_MAX_DIM][SM_MAX_DIM];	/*   ( ) */
static float _AA[SM_MAX_DIM][SM_MAX_DIM];	/*    ( ) */

static int _fV[SM_MAX_DIM];		/*  . - */
static int _bV[SM_MAX_DIM];		/*   - */
static float _T[SM_MAX_DIM][SM_MAX_DIM];	/* - */

static int _fV_[SM_MAX_DIM];		/*    . - */
static int _bV_[SM_MAX_DIM];		/*     - */
static float _T_[SM_MAX_DIM][SM_MAX_DIM];		/*   - */
static float _X[SM_MAX_DIM][SM_MAX_DIM];/* _X_0 -     */
													 /* _X_i -      i-  */
static float _Y[SM_MAX_DIM][SM_MAX_DIM];/* _Y_i -      i-  */

static int _n;							/*  . -  - */
static int _m;							/* .  -  - */

/* ==================================  ===============================*/
void 	_make_A(void);
void 	_writeData(void);
int 	_execSM( int n,int m,int *bV,int *fV,float *T);
void 	_copy(int n, int m, int *bV,int *fV,float *T,
				int *bV_,int *fV_,float *T_);
void	_roundX(int n,int m,float *x,float delta);
/*--------------------------------- main -------------------------------------*/
void main() {
   int done, i, j;

   assert(_N_>=2);
   assert(_R_<=(_N_-1)*2+1);

	_make_A();
   assert(_n+_m<SM_MAX_DIM);

	for (i=0; i<=_M_; i++)	//  A
	  	for (j=0; j<=_N_+_M_; j++)
            _AA[i][j]=_A[i][j];

   //  -  .. 
   done=sm_canonView(_N_+_M_,_M_,(void*)_A,&_n,&_m,_bV,_fV,(void*)_T);
	if (!done){
		printf("The problem's unresolvable.\n\nPress ENTER");
		getchar();
		abort();
	};

   //     
  	_copy(_n,_m,_bV,_fV,(void*)_T,_bV_,_fV_,(void*)_T_);
	done=_execSM(_n,_m,_bV_,_fV_,(void*)_T_);
	if (!done){
		printf("The problem's unresolvable.\n\nPress ENTER");
		getchar();
		abort();
	};

	sm_getX(_n,_m,_bV_,(void*)_T_,_X[0]);
   _roundX(_n,_m,_X[0],_DELTAX);

   //       
	for(i=1; i<=_R_; i++){
      for(j=0;j<=_N_;j++)
      	_AA[_M_-_R_+1][j]=_AA[_M_-_R_+i][j];
	   sm_canonView(_N_+_M_-_R_+1,_M_-_R_+1,(void*)_AA,&_n,&_m,_bV_,_fV_,(void*)_T_);
		done=_execSM(_n,_m,_bV_,_fV_,(void*)_T_);
		if (!done){
			printf("The problem's unresolvable.\n\nPress ENTER");
			getchar();
			abort();
		};
	  	sm_getX(_n,_m,_bV_,(void*)_T_,_X[i]);
   	_roundX(_n,_m,_X[i],_DELTAX);
   };

	for (i=0; i<=_M_; i++)	//  A
	  	for (j=0; j<=_N_+_M_; j++)
            _AA[i][j]=_A[i][j];

   //       

   for(j=0;j<=_N_;j++) //   
     	_AA[0][j]=-_AA[0][j];

	for(i=1; i<=_R_; i++){
      for(j=0;j<=_N_;j++)
      	_AA[_M_-_R_+1][j]=-_AA[_M_-_R_+i][j];
	   done=sm_canonView(_N_+_M_-_R_+1,_M_-_R_+1,(void*)_AA,&_n,&_m,_bV_,_fV_,(void*)_T_);
		if (!done){
			printf("Can't build canonic view.\n\nPress ENTER");
			getchar();
			abort();
		};
		done=_execSM(_n,_m,_bV_,_fV_,(void*)_T_);
		if (!done){
			printf("The problem's unresolvable.\n\nPress ENTER");
			getchar();
			abort();
		};
	  	sm_getX(_n,_m,_bV_,(void*)_T_,_Y[i]);
   	_roundX(_n,_m,_Y[i],_DELTAX);
   };



#ifndef _EXACT
   done=sm_canonView(_N_+_M_-_R_,_M_-_R_,(void*)_A,&_n,&_m,_bV,_fV,(void*)_T);
	if (!done){
		printf("The problem's unresolvable.\n\nPress ENTER");
		getchar();
		abort();
	};
#endif

	//  ( ) 
   for(j=1; j<=_n-_m; j++)
		_fV[j]=j;
   for(i=1; i<=_m; i++)
		_bV[i]=_n-_m+i;

	_writeData();

   printf("\n\nPress ENTER");getchar();/**/
};

/* =============================   ==========================*/
/*------------------------------- _make_A ----------------------------------*/
/*   A */
static void _make_A(){
   int	i, j;

	//      
	for (i=0; i<=_M_; i++)
	  	for (j=0; j<=_N_+_M_; j++)
            _A[i][j]=0;

	//    
   for (i=1; i<=_N_-1; i++){
		_A[i][1]=1;
		_A[i][i+1]=-2;
      _A[i][0]=0;
   };
   for (i=_N_; i<=2*(_N_-1); i++){
		_A[i][1]=1;
		_A[i][i-_N_+2]=2;
      _A[i][0]=8*_K;
   };

	// 
   // 1-  ():
   _A[_M_-_R_+1][0]=6*_K;
	_A[_M_-_R_+1][1]=(_N_-1)*3;
   for(j=2;j<=_N_;j++)
     	_A[_M_-_R_+1][j]=-1;
   //  ()
   #define m min(3*_N_-2,2*_N_-2+_R_)
   for(i=2*_N_;i<=m; i++){
	   for(j=2;j<=_N_;j++)
   	  	_A[i][j]=-0.01;/*0.1*/
		_A[i][1]=1;
		_A[i][i-_M_+_R_]=1;
      _A[i][0]=5*_K;
   };
   for (i=m+1; i<=_M_; i++){
	   for(j=2;j<=_N_;j++)
   	  	_A[i][j]=0;/*0.1*/
      _A[i][0]=1*_K;
		_A[i][1]=1;
		_A[i][i-m+1]=-1;
   };
	#undef m
   //    
   for(i=1; i<=_M_; i++)
     	_A[i][i+_N_]=1;

	//  
	_A[0][1]=-1;
};

/*------------------------------- _writeData ----------------------------------*/
/*    - */
static void _writeData() {
	FILE *stream;
   int	i, j;

	stream = fopen(_OUTPUT, "w+");
	if (stream== NULL){
		printf("Cannot open or create the output file.\n\nPress ENTER");
		getchar();
		abort();
	};

	fprintf(stream, "%%    (alpha=1, beta=gamma=2) \n");
   fprintf(stream, "%% n -   \n%d\n", _n);
   fprintf(stream, "%% m -   \n%d\n", _m);

	fprintf(stream, "\n%%    :\n");
	for (j=1; j<=_n-_m; j++)
		fprintf(stream, "%4.2f\t",_X[0][j]);


   fprintf(stream, "\n\n%% - \n\t");

  	for (j=1; j<=_n-_m; j++)
   	fprintf(stream, "%d\t", _fV[j]);
   fprintf(stream, "\n");
   for (i=1; i<=_m; i++){
   	fprintf(stream, "%d\t", _bV[i]);
   	for (j=1; j<=_n-_m; j++)
			fprintf(stream, "%d\t", (int)_A[i][j]);
	   fprintf(stream, "%d\t\n", (int)_A[i][0]);
	};
  	for (j=1; j<=_n-_m; j++)
   	fprintf(stream, "\t%d", (int)_A[0][j]);
   fprintf(stream, "\t%d\n\n", (int)_A[0][0]);

#ifndef _EXACT
   fprintf(stream, "%% r -   \n%d\n",_R_);
   fprintf(stream, "%%  <=  \n");
	// 
   for (i=_M_-_R_+1; i<=_M_; i++){
   	for(j=1;j<=_n-_m;j++)
	   	fprintf(stream, "%2.2f\t",_A[i][j]);
	  	for (j=_n-_m+1; j<=_n; j++)
	   	fprintf(stream, "0\t");
	   fprintf(stream, "%d\n",(int)(_A[i][0]));
   };

	fprintf(stream, "\n%%    +   :\n");
   for (i=1; i<=_R_; i++){

		for (j=1; j<=_n-_m; j++)

			fprintf(stream, "%4.2f\t",_X[i][j]);

	fprintf(stream, "\n");

	};


	fprintf(stream, "\n%%    +   :\n");
   for (i=1; i<=_R_; i++){

		for (j=1; j<=_n-_m; j++)

			fprintf(stream, "%4.2f\t",_Y[i][j]);

	fprintf(stream, "\n");

	};


   fprintf(stream, "\n%% kA -   A\n1\n");
   fprintf(stream, "%%   A:\n%d\t",4*_K);
  	for (j=2; j<=_n-_m; j++)
   	fprintf(stream, "%d\t",2*_K);
  	for (j=_n-_m+1; j<=_n; j++)
   	fprintf(stream, "0\t");
  	fprintf(stream, "\n\n");

   fprintf(stream, "%% kB -   B\n%d\n",_n-_m==2?2:_n-_m+1);
   fprintf(stream, "%%   B:\n");

  	for (j=1; j<=_n; j++)
   	fprintf(stream,"0\t");
  	fprintf(stream, "\n");
/*  	fprintf(stream,"%d\t",_K);
  	for (j=2; j<=_n-_m; j++)
   	fprintf(stream, "%d\t",_K/2);
  	for (j=_n-_m+1; j<=_n; j++)
   	fprintf(stream,"0\t");
  	fprintf(stream, "\n");/**/

   for (i=2; i<=_n-_m; i++){;
	  	for (j=1; j<=_n-_m; j++)
      	if(j==i)
		   	fprintf(stream, "%d\t",4*_K);
         else
		   	fprintf(stream, "0\t");
	  	for (j=_n-_m+1; j<=_n; j++)
   		fprintf(stream, "0\t");
	  	fprintf(stream, "\n");
   };

	if(_n-_m==2)
   	return;

  	fprintf(stream, "0\t");
  	for (j=2; j<=_n-_m; j++)
   	fprintf(stream, "%d\t",4*_K);
  	for (j=_n-_m+1; j<=_n; j++)
   	fprintf(stream, "0\t");
#endif
};


/* -------------------------------- _execSM ----------------------------------*/

/*    -  . */
static int /* :
			 1 -  ;
          0 -    */
_execSM( /* : */
	int n, 				/*  . - */
	int m, 		/* .  - */
	int *bV,		/*  - - (   1) */
	int *fV,		/*  - - (   1) */
	float *T	/* - (   ),
						  :
                  T_[0,0]=-Q_0;
                  T_[0,1..k] -    (k=n-m);
                  T_[1..m,0] -  b_i;
                  T_[1..m,1..k] -   */
){
	int done;
	/* ---------   ----------> */
   do{
	   done=sm_symplex(n,m,bV,fV,T);
		if (done==-1)
			return 0;
   }while(!done);

	return 1;
};

/* -------------------------------- _copy ------------------------------------*/
/*   -       

	 */

void _copy(
	int n, 				/*  . - */
	int m, 				/* .  - */
	int *bV,		/*  - - (   1) */
	int *fV,		/*  - - (   1) */
	float *T,	/* - */
	int *bV_,	/*    - - */
	int *fV_,	/*    - - */
	float *T_	/*   - */
){
#define a(i,j) T[(i)*SM_MAX_DIM+j]
#define a_(i,j) T_[(i)*SM_MAX_DIM+j]
   int i,j;
   int k=n-m;

   /*   - */
   for(i=0;i<=m;i++)
   	for(j=0;j<=k;j++)
	      a_(i,j)=a(i,j);
   for(i=1;i<=m;i++)
		bV_[i]=bV[i];
  	for(j=0;j<=k;j++)
		fV_[j]=fV[j];
#undef a_
#undef a
};

/* -------------------------------- _roundX ------------------------------------*/
//    -,      _x[]
static void _roundX( /* : */
	int n, 				/*  . - */
	int m, 				/* .  - */
	float *x,	/*  . x[0]    - */
	float delta	/*    */
){
	int j;

   //  x
  	for(j=1;j<=n-m;j++){
     	if(fabs(ROUND(x[j])-x[j])<delta)
				x[j]=ROUND(x[j]);
      if(x[j]<0)
      	x[j]=0;
//      assert(x[j]>=0);
   };

  	for(j=n-m+1;j<=n;j++)//   
     	x[j]=0;/**/
};

